﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.Text;

namespace WcfService1
{
    // メモ: [リファクター] メニューの [名前の変更] コマンドを使用すると、コードと config ファイルの両方で同時にインターフェイス名 "IService1" を変更できます。
    [ServiceContract]
    [XmlSerializerFormat]
    public interface IService1
    {
        CompositeType<OpState> Data {
            [OperationContract]
            get;
            [OperationContract]
            set;
        }
    }

    [DataContract]
    public enum OpState { NoConnection, Operating, Stopped }

    // サービス操作に複合型を追加するには、以下のサンプルに示すようにデータ コントラクトを使用します。
    [DataContract]
    public class CompositeType<T> where T : struct
    {
        T val;
        [DataMember]
        public T Value {
            get { return val; }
            set { val = value; }
        }
        string unit = string.Empty;
        [DataMember]
        public string Unit { get { return unit; } set { unit = value; } }
    }
    
}
